/*
 * Licensed from AIAIOO Labs.
 * Copyright holder :  Aiaioo Labs, cohan@aiaioo.com, (2008, 2009, 2010).
 * 
*
*  The software source code in this file and the other files in this library
*  are covered by a license from Aiaioo Labs.
* 
 * The terms and conditions of the license
 * may be obtained from Aiaioo Labs, Bangalore, India (cohan@aiaioo.com).
*/

package com.aiaioo.document;

/**
 * Class implementing a builder for text documents.
 * A document should be created only using the 'getInstance' static method in this class.
 * 
 * @author Cohan Sujay Carlos (cohan@aiaioo.com)
 * @version $Revision: 1.0 $ */

public class DocumentBuilder {
	
	/**
	 * Instantiates a document
	 * @param buffer the string of text as a String
	 * @return an instance of a document
	 */
	public static StringDocument getInstance(String buffer) {
		return new StringDocument(buffer);
	}

	/**
	 * Instantiates a document
	 * @param buffer the string of text as a StringBuffer
	 * @return an instance of a document
	 */
	public static StringDocument getInstance(StringBuffer buffer) {
		return new StringDocument(buffer);
	}
}
