/*
 * Licensed from AIAIOO Labs.
 * Copyright holder :  Aiaioo Labs, cohan@aiaioo.com, (2008, 2009, 2010).
 * 
*
*  The software source code in this file and the other files in this library
*  are covered by a license from Aiaioo Labs.
* 
 * The terms and conditions of the license
 * may be obtained from Aiaioo Labs, Bangalore, India (cohan@aiaioo.com).
*/

package com.aiaioo.sentence;

import java.util.ArrayList;
import java.util.List;

import com.aiaioo.util.Token;

public class SimpleParagraph implements Paragraph {
	private List<? extends Sentence> sentences;

	public SimpleParagraph(List<? extends Sentence> sentences) {
		this.sentences = sentences;
	}

	public StringBuffer getCharacters() {
		StringBuffer buffer = new StringBuffer();
		// NOT IMPLEMENTED
		return buffer;
	}

	public List<? extends Sentence> getSentences() {
		return sentences;
	}

	public boolean matches(TextSegment other) {
		for (Sentence sentence : sentences) {
			if (sentence.matches(other))
				return true;
		}
		return false;
	}
	
	public List<Token> getWords() {
		ArrayList<Token> tokens = new ArrayList<Token>();
		for (Sentence sentence : sentences) {
			tokens.addAll(sentence.getWords());
		}
		return tokens;
	}
	
	public int size() {
		int sum = 0;
		for (Sentence sentence : sentences) {
			sum += sentence.size();
		}
		return sum;
	}
	
}
