/*
 * Licensed from AIAIOO Labs.
 * Copyright holder :  Aiaioo Labs, cohan@aiaioo.com, (2008, 2009, 2010).
 * 
*
*  The software source code in this file and the other files in this library
*  are covered by a license from Aiaioo Labs.
* 
 * The terms and conditions of the license
 * may be obtained from Aiaioo Labs, Bangalore, India (cohan@aiaioo.com).
*/

package com.aiaioo.sentence;

import java.util.Iterator;
import java.util.List;

import com.aiaioo.util.Label;
import com.aiaioo.util.Token;

public class TaggedSentence extends SimpleSentence {
	private List<Label> tags;
	private double probability = 0.0;
	
	public TaggedSentence(List<Token> words, List<Label> tags) {
		super(words);
		this.tags = tags;
	}
	public List<Token> getWords() {
		return words;
	}
	public List<Label> getTags() {
		return tags;
	}
	public String toString() {
		StringBuffer buff = new StringBuffer();
		Iterator<Label> tagIt = tags.iterator();
		for (Token word : words) {
			Label tag = tagIt.hasNext() ? tagIt.next() : new Label("UNK");
			if (buff.length() > 0)
				buff = buff.append(" ");
			buff = buff.append(word).append("/").append(tag);
		}
		return buff.toString();
	}
	public boolean equals(Object f) {
		return (f == null || !(f instanceof TaggedSentence)) ? false : ((TaggedSentence)f).tags.equals(this.tags) && ((TaggedSentence)f).words.equals(this.words);
	}
	public double getProbability() {
		return probability;
	}
	public void setProbability(double probability) {
		this.probability = probability;
	}
}
