/*
 * Licensed from AIAIOO Labs.
 * Copyright holder :  Aiaioo Labs, cohan@aiaioo.com, (2008, 2009, 2010).
 * 
*
*  The software source code in this file and the other files in this library
*  are covered by a license from Aiaioo Labs.
* 
 * The terms and conditions of the license
 * may be obtained from Aiaioo Labs, Bangalore, India (cohan@aiaioo.com).
*/

package com.aiaioo.util;

import java.util.ArrayList;
import java.util.List;

public class NGram<T> implements Feature {
	protected List<T> tokens;

	public NGram() {
		tokens = new ArrayList<T>();
	}
	
	public NGram(List<T> tokens) {
		this.tokens = tokens;
	}
	
	public void addToken(T token) {
		tokens.add(token);
	}
	
	public List<T> getTokens() {
		return tokens;
	}
	
	public T get(int i) {
		return tokens.get(i);
	}
	
	public int size() {
		return tokens.size();
	}

	public NGram<T> subSequence(int start, int end) {
		return new NGram<T>(tokens.subList(start, end));
	}

	public boolean equals(Object f) {
		if (f == null || !( f instanceof NGram<?> ))
			return false;
		return ((NGram<T>)f).getTokens() == getTokens() || getTokens() != null && getTokens().equals(((NGram<T>)f).getTokens());
	}
	
	public int hashCode() {
		int hash = 0;
		if (getTokens() == null)
			return hash;
		for (T token : getTokens())
			hash = hash*37127+token.hashCode();
		return hash;
	}
	
	public String toString() {
		return tokens.toString();
	}

	public String getValue() {
		return tokens.toString();
	}
}
