/*
 * Licensed from AIAIOO Labs.
 * Copyright holder :  Aiaioo Labs, cohan@aiaioo.com, (2008, 2009, 2010).
 * 
*
*  The software source code in this file and the other files in this library
*  are covered by a license from Aiaioo Labs.
* 
 * The terms and conditions of the license
 * may be obtained from Aiaioo Labs, Bangalore, India (cohan@aiaioo.com).
*/

package com.aiaioo.util;

/**
 * The range holds the first element and the last element of the sub list.
 * Both the first and the last element indices are zero-based.
 * 
 * @author Cohan
 */
public class Range {
	protected long begin, end;
	
	public Range(long begin, long end) {
		if (begin < end) {
			this.begin = begin;
			this.end = end;
		} else {
			this.begin = end;
			this.end = begin;
		}
	}

	public long getEnd() {
		return end;
	}

	public long getStart() {
		return begin;
	}
	
	public boolean isGreaterThan(Range other) {
		return (this.end - this.begin) > (other.getEnd() - other.getStart());
	}
	
	public boolean equals(Object other) {
		return other != null && other instanceof Range && ((Range)other).getStart() == getStart() && ((Range)other).getEnd() == getEnd();
	}
	
	public String toString() {
		return "["+this.begin+","+this.end+"]";
	}
}
