package com.aiaioo.api;

import java.net.MalformedURLException;
import java.util.ArrayList;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.aiaioo.event.DocumentEvent;
import com.aiaioo.event.EntityEvent;
import com.aiaioo.event.Event;
import com.aiaioo.event.EventType;
import com.aiaioo.sentence.TextSegment;
import com.aiaioo.util.StringEntity;

/*
 * 										DO NOT USE
 * 
 * 								This API is not fully trained yet
 * 						 (our training data volumes are still too low)
 * 
 */

public class VakEventClient extends Client {
	
	String url = "http://"+getServerHostname()+"/apis/vakevent/";

	public VakEventClient() {
		super();
	}
	
	public void setServerHostname(String hostname) {
		super.setServerHostname(hostname);
		url = "http://"+getServerHostname()+"/apis/vakevent/";
	}
	
	public ArrayList<Event> getEvents(ArrayList<String> list) throws ClientException {
		ArrayList<Event> intentions = new ArrayList<Event>();
		if (list == null || list.size() == 0)
			return intentions;
		String str = convertToXML(list);
		String params = "key="+key+"&v="+getVersionDetails()+"&text="+str;
		try {
			Document document = parseXmlFile(new java.net.URL(url), params);
			if (document != null) {
				performVersioningChecks(document);
				int code = Integer.parseInt(document.getChildNodes().item(0).getChildNodes().item(0).getTextContent());
				if (code == 0) {
					// request processed successfully
					Node documents = document.getChildNodes().item(0).getChildNodes().item(1).getChildNodes().item(0);
					for (int i = 0 ; i < documents.getChildNodes().getLength() ; ++i) {
						Element doc = (Element)documents.getChildNodes().item(i);

						//int index = Integer.parseInt(doc.getChildNodes().item(0).getTextContent());
						String text = doc.getChildNodes().item(1).getTextContent();
						String intention = doc.getChildNodes().item(2).getTextContent();
						String polarity = doc.getChildNodes().item(3).getTextContent();

						DocumentEvent di = new DocumentEvent();
						di.setText(com.aiaioo.document.DocumentBuilder.getInstance(text));
						di.setEventType(EventType.getEventType(intention));
						di.setNegated("negative".equals(polarity));

						intentions.add(di);
						
						NodeList sentences = doc.getElementsByTagName("sentence");
						for (int j = 0 ; j < sentences.getLength() ; ++j) {
							Node sentence = sentences.item(j);
							
							//int indexS = Integer.parseInt(sentence.getChildNodes().item(0).getTextContent());
							String textS = sentence.getChildNodes().item(1).getTextContent();
							String intentionS = sentence.getChildNodes().item(2).getTextContent();
							String polarityS = sentence.getChildNodes().item(3).getTextContent();

							EntityEvent ei = new EntityEvent();
							TextSegment sent = com.aiaioo.document.DocumentBuilder.getInstance(textS);
							ei.setText(sent);
							ei.setEventType(EventType.getEventType(intentionS));
							ei.setNegated("negative".equals(polarityS));

							di.addSentenceEvent(sent, ei);
							
							if (sentence.getChildNodes().getLength() > 4 && "actors".equals(sentence.getChildNodes().item(4).getNodeName())) {
								Node objects = sentence.getChildNodes().item(4);
								for (int k = 0 ; k < objects.getChildNodes().getLength() ; ++k) {
									Node object = objects.getChildNodes().item(k);
									
									String textO = object.getChildNodes().item(0).getTextContent();
									String polarityO = object.getChildNodes().item(1).getTextContent();
	
									ei.addActor(new StringEntity(textO), "negative".equals(polarityO));
	
								}
							}
							if (sentence.getChildNodes().getLength() > 5 && "experiencers".equals(sentence.getChildNodes().item(5).getNodeName())) {
								Node holders = sentence.getChildNodes().item(5);
								for (int k = 0 ; k < holders.getChildNodes().getLength() ; ++k) {
									Node object = holders.getChildNodes().item(k);
									
									String textO = object.getChildNodes().item(0).getTextContent();
									String polarityO = object.getChildNodes().item(1).getTextContent();
	
									ei.addExperiencer(new StringEntity(textO), "negative".equals(polarityO));
	
								}
							}
							if (sentence.getChildNodes().getLength() > 6 && "objects".equals(sentence.getChildNodes().item(6).getNodeName())) {
								Node alternatives = sentence.getChildNodes().item(5);
								for (int k = 0 ; k < alternatives.getChildNodes().getLength() ; ++k) {
									Node object = alternatives.getChildNodes().item(k);
									
									String textO = object.getChildNodes().item(0).getTextContent();
									String polarityO = object.getChildNodes().item(1).getTextContent();
	
									ei.addObject(new StringEntity(textO), "negative".equals(polarityO));
	
								}
							}
						}

					}
				} else {
					String error = document.getChildNodes().item(0).getChildNodes().item(1).getTextContent();
					if (code == 4)
						throw new ClientException("API key: "+key+".  "+error);
					throw new ClientException(error);
				}
			} else {
				throw new ClientException("Did not receive data from the server.  This is either an internet connectivity problem or faulty XML was returned.");
			}
		} catch (MalformedURLException e) {
			e.printStackTrace();
		} catch (NumberFormatException ex) {
			ex.printStackTrace();
		}
		return intentions;
	}

	public static void main(String[] args) {
		
		try {
			
			ArrayList<String> documents = new ArrayList<String>();
			documents.add("Nokia acquired Motorola Mobility for $5 billion.");
			documents.add("Videocon Industries is looking to sell a 25% stake in its direct-to-home business for roughly $75 million and is in talks with private equity firms.");
			ArrayList<Event> events = new VakEventClient().getEvents(documents);
			System.out.println(events);
			
		} catch (ClientException e) {
			System.err.println("Error: "+e.getMessage());
		}
	}

}
