package com.aiaioo.event;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.Map;

import com.aiaioo.sentence.TextSegment;

public class DocumentEvent extends EntityEvent {

	protected Map<TextSegment, Event> sentenceEvent = Collections.synchronizedMap(new LinkedHashMap<TextSegment, Event>());

	public DocumentEvent() {
		super();
	}
		
	public void addSentenceEvent(TextSegment textSegment, Event sentiment) {
		sentenceEvent.put(textSegment, sentiment);
	}
	
	public Map<TextSegment, Event> getSentenceEvent() {
		return sentenceEvent;
	}

	public String toString() {
		StringBuffer buffer = new StringBuffer(super.toString());
		int count = 0;
		for (TextSegment textSegment : sentenceEvent.keySet()) {
			++count;
			buffer.append("Sentence "+count+": ");
			buffer.append(sentenceEvent.get(textSegment).toString());
		}
		return buffer.toString();
	}

	public String toXMLString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append(super.toXMLString());
		int count = 0;
		buffer.append("<sentences>");
		for (TextSegment textSegment : sentenceEvent.keySet()) {
			++count;
			buffer.append("<sentence>");
			buffer.append("<index>"+count+"</index>");
			buffer.append(sentenceEvent.get(textSegment).toXMLString());
			buffer.append("</sentence>");
		}
		buffer.append("</sentences>");
		return buffer.toString();
	}

	public String toWebString() {
		StringBuffer buffer = new StringBuffer();
		if (sentenceEvent.size() > 1) {
			buffer.append("Document: ");
			buffer.append(super.toWebString());
			buffer.append("<br/>");
		}
		int count = 0;
		for (TextSegment textSegment : sentenceEvent.keySet()) {
			++count;
			buffer.append("Sentence "+count+": ");
			buffer.append(sentenceEvent.get(textSegment).toWebString());
			buffer.append("<br/>");
		}
		return buffer.toString();
	}
}
