package com.aiaioo.event;

import com.aiaioo.sentence.TextSegment;

public class Event {

	protected EventType type;
	protected TextSegment text;
	protected boolean isNegated = false;
	
	public Event() {
	}

	public EventType getEventType() {
		return type;
	}

	public void setEventType(EventType type) {
		this.type = type;
	}

	public TextSegment getText() {
		return text;
	}

	public void setText(TextSegment text) {
		this.text = text;
	}

	public boolean isNegated() {
		return isNegated;
	}

	public void setNegated(boolean isNegated) {
		this.isNegated = isNegated;
	}

	public String toString() {
		return getText().toString();
	}

	
	public String toXMLString() {
		return escapeXML(toString());
	}
	
	public String toWebString() {
		return toString();
	}
	
	public String escapeXML(String myString) {
		myString = myString.replaceAll("&", "&amp;");
		myString = myString.replaceAll("<", "&lt;");
		myString = myString.replaceAll(">", "&gt;");
		myString = myString.replaceAll("'", "&apos;");
		myString = myString.replaceAll("\"", "&quot;");
		return myString;
	}

	public String escapeXMLBig(String myString) {
		return "<![CDATA[" + myString.replaceAll("]]>", "]]>]]><![CDATA[") + "]]>";
	}
}
