package com.aiaioo.event;

import com.aiaioo.util.Label;

public class EventType {
	// Corporate
	public static final EventType acquisition = new EventType(new Label("acquisition"));
	public static final EventType merger = new EventType(new Label("merger"));
	public static final EventType spin_off = new EventType(new Label("spin_off"));
	public static final EventType sale = new EventType(new Label("sale"));
	public static final EventType partnership_formation = new EventType(new Label("partnership"));
	public static final EventType expansion = new EventType(new Label("expansion"));
	public static final EventType renaming = new EventType(new Label("renaming"));
	public static final EventType closing_down = new EventType(new Label("close_down"));

	// Financial
	public static final EventType investment = new EventType(new Label("investment"));
	public static final EventType ipo = new EventType(new Label("IPO"));
	public static final EventType bankruptcy_declaration = new EventType(new Label("bankruptcy"));

	// Operations
	public static final EventType opening_facility = new EventType(new Label("facility"));
	public static final EventType talks = new EventType(new Label("talks"));
	public static final EventType strike_deal = new EventType(new Label("strike_deal"));
	public static final EventType win = new EventType(new Label("win"));
	public static final EventType loss = new EventType(new Label("loss"));

	// Products
	public static final EventType product_launch = new EventType(new Label("prod_launch"));
	public static final EventType product_withdrawal = new EventType(new Label("prod_pull"));
	public static final EventType buy = new EventType(new Label("buy"));
	public static final EventType sell = new EventType(new Label("sell"));

	// Human Resource
	public static final EventType appointment = new EventType(new Label("appointment"));
	public static final EventType leaving = new EventType(new Label("leaving"));

	public static final EventType other = new EventType(new Label("other")); // *

	private Label label;
	
	private EventType(Label label) {
		this.label = label;
	}
	
	public String toString() {
		return this.label.toString();
	}

	public Label getLabel() {
		return this.label;
	}

	public static EventType getEventType(String event) {
		if ("acquisition".equals(event))
			return acquisition;
		else if ("merger".equals(event))
			return merger;
		else if ("spin_off".equals(event))
			return spin_off;
		else if ("sale".equals(event))
			return sale;
		else if ("partnership".equals(event))
			return partnership_formation;
		else if ("expansion".equals(event))
			return expansion;
		else if ("renaming".equals(event))
			return renaming;
		else if ("close_down".equals(event))
			return closing_down;
		else if ("investment".equals(event))
			return investment;
		else if ("IPO".equals(event))
			return ipo;
		else if ("bankruptcy".equals(event))
			return bankruptcy_declaration;
		else if ("facility".equals(event))
			return opening_facility;
		else if ("strike_deal".equals(event))
			return strike_deal;
		else if ("talks".equals(event))
			return talks;
		else if ("win".equals(event))
			return win;
		else if ("loss".equals(event))
			return loss;
		else if ("buy".equals(event))
			return buy;
		else if ("sell".equals(event))
			return sell;
		else if ("prod_launch".equals(event))
			return product_launch;
		else if ("prod_pull".equals(event))
			return product_withdrawal;
		else if ("appointment".equals(event))
			return appointment;
		else if ("leaving".equals(event))
			return leaving;
		else if ("other".equals(event))
			return other;
		return other;
	}
}
