package com.aiaioo.intention;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.Map;

import com.aiaioo.sentence.TextSegment;

public class DocumentIntention extends EntityIntention {

	protected Map<TextSegment, Intention> sentenceIntention = Collections.synchronizedMap(new LinkedHashMap<TextSegment, Intention>());

	public DocumentIntention() {
		super();
	}
		
	public void addSentenceIntention(TextSegment textSegment, Intention sentiment) {
		sentenceIntention.put(textSegment, sentiment);
	}
	
	public Map<TextSegment, Intention> getSentenceIntention() {
		return sentenceIntention;
	}

	public String toString() {
		StringBuffer buffer = new StringBuffer(super.toString());
		int count = 0;
		for (TextSegment textSegment : sentenceIntention.keySet()) {
			++count;
			buffer.append("Sentence "+count+": ");
			buffer.append(sentenceIntention.get(textSegment).toString());
		}
		return buffer.toString();
	}

	public String toXMLString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append(super.toXMLString());
		int count = 0;
		buffer.append("<sentences>");
		for (TextSegment textSegment : sentenceIntention.keySet()) {
			++count;
			buffer.append("<sentence>");
			buffer.append("<index>"+count+"</index>");
			buffer.append(sentenceIntention.get(textSegment).toXMLString());
			buffer.append("</sentence>");
		}
		buffer.append("</sentences>");
		return buffer.toString();
	}

	public String toWebString() {
		StringBuffer buffer = new StringBuffer();
		if (sentenceIntention.size() > 1) {
			buffer.append("Document: ");
			buffer.append(super.toWebString());
			buffer.append("<br/>");
		}
		int count = 0;
		for (TextSegment textSegment : sentenceIntention.keySet()) {
			++count;
			buffer.append("Sentence "+count+": ");
			buffer.append(sentenceIntention.get(textSegment).toWebString());
			buffer.append("<br/>");
		}
		return buffer.toString();
	}
}
