package com.aiaioo.intention;

import com.aiaioo.util.Label;

public class IntentionType {
	public static final IntentionType purchase = new IntentionType(new Label("purchase")); // +* sales
	public static final IntentionType sell = new IntentionType(new Label("sell")); // +* procurement
	public static final IntentionType suggest = new IntentionType(new Label("suggest")); // +* market research
	public static final IntentionType compare = new IntentionType(new Label("compare")); // ... * market research

	public static final IntentionType complain = new IntentionType(new Label("complain")); // ... * customer service
	public static final IntentionType accuse = new IntentionType(new Label("accuse")); // +* customer service
	public static final IntentionType quit = new IntentionType(new Label("quit")); // +* customer service
	public static final IntentionType express = new IntentionType(new Label("express")); // +* training - thank, apologize, empathize
	
	public static final IntentionType inquire = new IntentionType(new Label("inquire")); // +* technical support
	public static final IntentionType direct = new IntentionType(new Label("direct")); // +* operations

	public static final IntentionType opine = new IntentionType(new Label("opine")); // + done - market research - planning
	public static final IntentionType praise = new IntentionType(new Label("praise")); // + done - market research - planning
	public static final IntentionType criticise = new IntentionType(new Label("criticise")); // + done - market research - planning

	// Parts of express - not used at the moment
	public static final IntentionType thank = new IntentionType(new Label("thank")); // *
	public static final IntentionType apologize = new IntentionType(new Label("apologize")); // *
	public static final IntentionType empathize = new IntentionType(new Label("empathize")); // *
	public static final IntentionType wish = new IntentionType(new Label("wish")); // *

	public static final IntentionType meet = new IntentionType(new Label("meet")); // *

	public static final IntentionType other = new IntentionType(new Label("other")); // *

	private Label label;
	
	private IntentionType(Label label) {
		this.label = label;
	}
	
	public String toString() {
		return this.label.toString();
	}

	public Label getLabel() {
		return this.label;
	}
	
	public static IntentionType getIntentionType(String name) {
		if ("purchase".equals(name))
			return purchase;
		else if ("sell".equals(name))
			return sell;
		else if ("suggest".equals(name))
			return suggest;
		else if ("compare".equals(name))
			return compare;
		
		else if ("complain".equals(name))
			return complain;
		else if ("accuse".equals(name))
			return accuse;
		else if ("quit".equals(name))
			return quit;
		else if ("express".equals(name))
			return express;

		else if ("inquire".equals(name))
			return inquire;
		else if ("direct".equals(name))
			return direct;

		else if ("opine".equals(name))
			return opine;
		else if ("praise".equals(name))
			return praise;
		else if ("criticise".equals(name))
			return criticise;
		
		else if ("thank".equals(name))
			return thank;
		else if ("apologize".equals(name))
			return apologize;
		else if ("empathize".equals(name))
			return empathize;
		else if ("wish".equals(name))
			return wish;

		else if ("meet".equals(name))
			return meet;
		else if ("other".equals(name))
			return other;

		else
			return other;
	}
}
