package com.aiaioo.sentiment;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.Map;

import com.aiaioo.sentence.TextSegment;

public class DocumentSentiment extends EntitySentiment {

	protected Map<TextSegment, Sentiment> sentenceSentiment = Collections.synchronizedMap(new LinkedHashMap<TextSegment, Sentiment>());

	public DocumentSentiment() {
	}

	public DocumentSentiment(double value) {
		super(value);
	}
	
	public DocumentSentiment(double value, SentimentType type) {
		super(value, type);
	}
	
	public DocumentSentiment(double value, SentimentType type, TextSegment text) {
		super(value, type, text);
	}
		
	public void addSentenceSentiment(TextSegment textSegment, Sentiment sentiment) {
		sentenceSentiment.put(textSegment, sentiment);
	}
	
	public Map<TextSegment, Sentiment> getSentenceSentiment() {
		return sentenceSentiment;
	}

	public String toString() {
		StringBuffer buffer = new StringBuffer(super.toString());
		int count = 0;
		for (TextSegment textSegment : sentenceSentiment.keySet()) {
			++count;
			buffer.append("Sentence "+count+": ");
			buffer.append(sentenceSentiment.get(textSegment).toString());
		}
		return buffer.toString();
	}

	public String toXMLString() {
		StringBuffer buffer = new StringBuffer();
		buffer.append(super.toXMLString());
		int count = 0;
		buffer.append("<sentences>");
		for (TextSegment textSegment : sentenceSentiment.keySet()) {
			++count;
			buffer.append("<sentence>");
			buffer.append("<index>"+count+"</index>");
			buffer.append(sentenceSentiment.get(textSegment).toXMLString());
			buffer.append("</sentence>");
		}
		buffer.append("</sentences>");
		return buffer.toString();
	}

	public String toWebString() {
		StringBuffer buffer = new StringBuffer();
		if (sentenceSentiment.size() > 1) {
			buffer.append("Document: ");
			buffer.append(super.toWebString());
			buffer.append("<br/>");
		}
		int count = 0;
		for (TextSegment textSegment : sentenceSentiment.keySet()) {
			++count;
			buffer.append("Sentence "+count+": ");
			buffer.append(sentenceSentiment.get(textSegment).toWebString());
			buffer.append("<br/>");
		}
		return buffer.toString();
	}
}
