package com.aiaioo.sentiment;

import com.aiaioo.util.Label;

public class SentimentType {
	public static final SentimentType positive = new SentimentType(new Label("positive"));
	public static final SentimentType negative = new SentimentType(new Label("negative"));
	public static final SentimentType happy = new SentimentType(new Label("happy"));
	public static final SentimentType sad = new SentimentType(new Label("sad"));
	public static final SentimentType neutral = new SentimentType(new Label("neutral"));
	public static final SentimentType question = new SentimentType(new Label("question"));
	public static final SentimentType imperative = new SentimentType(new Label("imperative"));

	private Label label;
	
	private SentimentType(Label label) {
		this.label = label;
	}
	
	public String toString() {
		return this.label.toString();
	}

	public Label getLabel() {
		return this.label;
	}
	
	public static SentimentType getSentimentType(String name) {
		if ("positive".equals(name))
			return positive;
		else if ("negative".equals(name))
			return negative;
		else
			return neutral;
	}
}
